<?php
// admin_placeutilslevel.php - Script created by Robin Richmond's Place Utilities mod to populate the placelevel field in the places table. 
// The algorithm for setting place levels is strictly dependent on a place name-formatting standard, described
// in the help file.
// Placelevel=0 Unknown level
//            1 Address
//            2 Location
//            3 City/Town
//            4 County/Shire
//            5 State/Province
//            6 Country

include("begin.php");
if( !$cms['support'] ) $cms['tngpath'] = "";
include($cms['tngpath'] ."adminlib.php");
$textpart = "findplace";
include($cms['tngpath'] ."getlang.php");
include($cms['tngpath'] ."$mylanguage/admintext.php");
tng_db_connect($database_host,$database_name,$database_username,$database_password) or exit;
$admin_login = 1;
include($cms['tngpath'] ."checklogin.php");
include($cms['tngpath'] ."version.php");

$stateNameArray = array();
$stAbArray = array();
loadstates(); //Load state names and abbreviations into a lookup table.

$extraStateNames = ""; //Will be updated by the place format config file if it exists.

// Include the site-specific place format config file if it exists. Otherwise, include the distribution version.
if (file_exists("extensions/placeformatconfig.php")) include("extensions/placeformatconfig.php"); 
else include("extensions/placeformatconfig-placedistrib.php");
//Add the extra states from the include file. 
$extraStates=array();
$extraStates=explode("|", $extraStateNames);
for ($i=0; $i<count($extraStates); $i++) $stateNameArray[$extraStates[$i]] = "";

$orgtree = $tree;
$helplang = findhelp("placeutilities_help.php");

$flags['tabs'] = $tngconfig['tabs'];
tng_adminheader( $admtext['mpu-setupplacelevel'], $flags );
?>
<script type="text/javascript" src="js/admin.js"></script>
<script type="text/javascript" language="javascript">
// jQuery function to show/hide a list of places, and switch between buttons that say
// "see them" or "hide them"
function showlist(thisid) {
	if (jQuery("#"+thisid+"but").val()=="<?php echo $admtext['mpu-seethem']; ?>") {
		jQuery("#"+thisid).show();
		jQuery("#"+thisid+"but").val("<?php echo $admtext['mpu-hidethem']; ?>");
	} else {
		jQuery("#"+thisid).hide();
		jQuery("#"+thisid+"but").val("<?php echo $admtext['mpu-seethem']; ?>");
	}
}
jQuery(document).ready(function() {
	jQuery("#level0listbut").click(
		function(event) { showlist("level0list"); }
	);
});
</script>
<style>
#level0list {display:none;}
</style>

</head>

<body background="img/background.gif">

<?php

	// Placetabs 0-3 are standard; 4-6 are from the Place Utilities mod.
	$placetabs[0] = array(1,"admin_places.php",$admtext['search'],"findplace");
	$placetabs[1] = array($allow_add,"admin_newplace.php",$admtext['addnew'],"addplace");
	$placetabs[2] = array($allow_edit && $allow_delete,"admin_mergeplaces.php",$admtext['merge'],"merge");
	$placetabs[3] = array($allow_edit,"admin_geocodeform.php",$admtext['geocode'],"geo");
	$placetabs[4] = array($allow_edit,"admin_placeutilslevel.php",$admtext['mpu-placelevels'],"level");
	$placetabs[5] = array($allow_edit,"admin_placeutilsload.php",$admtext['mpu-fromfile'],"fromfile");
	$placetabs[6] = array(1,"admin_placeutilssave.php",$admtext['mpu-savefile'],"savefile");
	$placetabs[7] = array($allow_edit,"admin_placeutilsoptions.php",$admtext['mpu-options'],"options");
	$innermenu = "<a href=\"#\" onclick=\"return openHelp('$helplang/placeutilities_help.php');\" class=\"lightlink\">{$admtext['help']}</a>";
	$menu = doMenu($placetabs,"level",$innermenu);
	echo displayHeadline($admtext['places'] . " &gt;&gt; " . $admtext['mpu-setupplacelevel'], "img/places_icon.gif",$menu,$message);
?>
<table width="100%" border="0" cellpadding="10" cellspacing="2" class="lightback">
<tr class="databack">
<td class="tngshadow normal">

<?php
	if( !$tree1 && $assignedtree && !$tngconfig['places1tree'] )
		$tree1 = $assignedtree;
	if ( $tree1) $wherestr = "WHERE gedcom = \"$tree1\"";
	else $wherestr = "WHERE 1=1";

	//Before displaying the form, take any action that was specified by button b1
	if ($b1 == $admtext['mpu-completelyrepouplate']) {
		populatePlaceLevel("all");
	}
	else if ($b1 == $admtext['mpu-populateundefined']) {
		populatePlaceLevel("0");
	}
	else if ($b1 == $admtext['mpu-settozero']) {
		$treestr = $tree1 ? " WHERE gedcom = \"$tree1\"" : "";
		$query = "UPDATE $places_table SET placelevel=0 $treestr";
		$result = tng_query($query);
		echo "<h4>{$admtext['mpu-settozero']}";
		if ($tree1) echo " {$admtext['mpu-intree']} $tree1 ";
		echo "</h4>";
	}
	// End of actions

	echo "<form>";
	$treequery = "SELECT gedcom, treename FROM $trees_table ORDER BY treename";
	if(!$tngconfig['places1tree']) {
		//Places ARE separated into trees.
		$treeresult = tng_query($treequery) or die ($admtext['cannotexecutequery'] . ": $treequery");
		if (tng_num_rows($treeresult) == 1) {
			$treerow = tng_fetch_assoc($treeresult);
			echo "<input type=\"hidden\" name=\"tree1\" value=\"{$treerow['gedcom']}\" /></th>\n";
		} else {
			echo "<select name=\"tree1\" onchange=\"this.form.submit();\">\n";
			echo "	<option value=\"\">{$admtext['alltrees']}</option>\n";
			while( $treerow = tng_fetch_assoc($treeresult) ) {
				echo "	<option value=\"{$treerow['gedcom']}\"";
				if( $treerow['gedcom'] == $tree1 ) echo " selected";
				echo ">{$treerow['treename']}</option>\n";
			}
			echo "</select>";
		}
		tng_free_result($treeresult);
	}
	
	//Get and display the placelevel counts
	$query = "SELECT count(*) as total FROM $places_table " . $wherestr;
	$result = @tng_query($query);;
	$row = tng_fetch_assoc($result);
	echo "<br/>Total number of places: {$row['total']}";
	tng_free_result($result);

	$query = "SELECT gedcom,place FROM $places_table $wherestr AND placelevel=0 ORDER BY gedcom,place;";
	$result = @tng_query($query);
	$total = tng_num_rows($result);
	echo "<br/>Number of places where placelevel is zero: $total ";
	if ($total) {
		echo "<input type=\"button\" id=\"level0listbut\" value=\"{$admtext['mpu-seethem']}\" />";
		echo "<ol style=\"border-top:0;border-bottom:0;\" id=\"level0list\">\n";
		while( $row = tng_fetch_assoc($result) ) {
			echo "<li>{$row['gedcom']} - {$row['place']}</li>\n";
		}
		echo "</ol>";
	}
	echo "<br/><br/>";
	tng_free_result($result);

	//Display 3 buttons for the user to choose from.
	echo "<input type=\"submit\" name=\"b1\" value=\"{$admtext['mpu-completelyrepouplate']}\" />\n";
	echo "<br>{$admtext['text_or']} <input type=\"submit\" name=\"b1\" value=\"{$admtext['mpu-populateundefined']}\" />\n";
	echo "<br>{$admtext['text_or']} <input type=\"submit\" name=\"b1\" value=\"{$admtext['mpu-settozero']}\" />\n";
?>
	</form>
</td>
</tr>
</table>
<?php echo "<div align=\"right\"><span class=\"normal\">$tng_title, v.$tng_version</span></div>"; ?>
</body>
</html>
<?php

//*****************************************************************************
//****************** end of "main" program.  Functions follow *****************
//*****************************************************************************

function populatePlaceLevel($whattodo) {
	//Populate the placelevel field in the Places table.
	//The input parameter $whattodo may be "all" or "0".  It directs the function to populate all Places
	//records, or only those whose placelevel values are 0.
	global $stateNameArray, $stAbArray; //Lists of state names and abbreviations
	global $places_table, $admtext;
	//Options stored in the place format configuration file.
	global $usaText,$blnUseFullname,$countyWithCity,$countyWithoutCity,$nonCounties,$nonCityStrings,$cemeteryStrings,$placesToIgnore;
	global $tree1; //The selected tree. Blank means do all trees.
	$treestr = $tree1 ? " AND gedcom = \"$tree1\"" : "";
	$wherestr = $whattodo=="0" ? " AND (placelevel = 0)" : "";

	//Add commas to both sides of list of places to ignore to facilitate searching.
	$placesToIgnore = "," . str_replace(", ",",",$placesToIgnore) . ",";
	//Explode the lists of sub-strings into arrays so we can search for them.
	$cemeteryArray = explode(",",$cemeteryStrings);
	trimArray ($cemeteryArray);
	$nonCityArray = explode(",",$nonCityStrings);
	trimArray ($nonCityArray);
	$nonCountyArray=array();
	$x = explode(";",$nonCounties); 
	trimArray ($nonCountyArray);
	for ($i = 0; $i<count($x); $i++) {
		$nonCountyArray[$i] = explode(",",trim($x[$i]));
		for ($j = 0; $j<2; $j++) {
			$nonCountyArray[$i][$j] = trim($nonCountyArray[$i][$j]);
		}
	}

	//Get all placesnames, along with the tree ID and step through them
	$query = "SELECT ID, place, placelevel FROM $places_table WHERE 1=1 $treestr $wherestr ORDER BY gedcom,place";
	$result = tng_query($query);
	$updatecount = 0; //Counts updated places
	echo tng_num_rows($result) . " records selected.";
	while( $row = tng_fetch_assoc($result)) {
		$placename = trim($row["place"]);
		$gedcom = ($row['gedcom']) ? $row['gedcom'] : "level0";

		//Look for this place in the list of places to ignore
		if (stripos($placesToIgnore, ",".$placename.",") == false) {
			$level=0; //Start by assuming that the level couldn't be set
			$id = $row["ID"];
			$separator = ",";
			if (strpos($placename, ", ") !== false) $separator=", ";
			$commaparts = explode($separator,$placename);
			$commapartscount = count($commaparts);
			$lastpart = $commaparts[$commapartscount-1];
			//Figure out if this is a USA place.
			$usaplace = false;
			if ($lastpart == "USA" || $lastpart == "United States") {
				$usaplace = true;
				$commapartscount = $commapartscount - 1;  //We'll ignore the USA country part
			} elseif (array_key_exists($lastpart, $stateNameArray) || array_key_exists($lastpart,$stAbArray) ) {
				$usaplace = true;
			}
		
			if ($usaplace) {
				switch ($commapartscount) {
				case 0; $level = 6; // USA - country

				case 1: $level = 5; //One-part name. It must be a state
					break;

				case 2: //Two-part name. The first part is either a county or a town.
					//We can tell for sure if there is a county designator ("Co" or "County") in the first part.
					if (substr($commaparts[0],strlen($commaparts[0])-3) == " Co" || 
						substr($commaparts[0],strlen($commaparts[0])-7)==" County") {
						$level = 4; //County
					} else {
						//In the absence of a county designator, look for a non-county that act as a county.
						//(e.g. Long Island,NY or Shenandoah Valley,VA)
						//The non-counties that act as counties have two parts, the non-county county,
						//and the state abbreviation.  We have to check for state names as well
						//as state abbreviation.  The state abbreviation array values are the state names.
						//(e.g. $stAbArray["NY"]="New York")
						for ($i=0; $i<count($nonCountyArray); $i++) {
							if ($commaparts[0] == $nonCountyArray[$i][0] &&
								( $commaparts[1] == $nonCountyArray[$i][1] ||
									$commaparts[1] == $stAbArray[$nonCountyArray[$i][1]])) {
								$level = 4; //Non-counties are marked as county level
								break;
							}
						}
					}
					if (!$level) $level = 3; //Town
					break;

					case 3: //City, county, state, or location, county, state or location, town, state
					//The only locations we can specifically recognize are cemeteries
					if (findInArray($commaparts[0],$cemeteryArray) !== false) {
						$level=2; //location
					} else {
						//If the second part (part 1) is marked as a county then we'll have
						//to consider other program options.
						//If the countyWithCity option is blank, a county designator on part 1
						//means part 0 is a location, and the lack of a county designator
						//means part 0 is a town.
						//But if $countyWithCity is non-blank, we can't really infer a meaning
						//to part 0; we'll just have to call it a town UNLESS it's in the 
						//"not a city" list, in which case its a county.
						if ($countyWithCity == $countyWithoutCity ) {
							// Whether part 1 is marked as a county is irrelevant; all we can do is look for
							//non-city substrings in part 0.
							if (findInArray($commaparts[0],$cemeteryArray) !== false) {
								$level = 4; //County
							} else $level = 3; //Town
						} else {
							// The presence the $countyWithoutCity designator in part 1
							// tells us that part 1 is a location rather than a city.
							if (strlen($commaparts[1])>(strlen($countyWithoutCity)+1)  &&
								substr($commaparts[1],(strlen($countyWithoutCity)+1)) == (" " . $countyWithoutCity)) {
								if (findInArray($commaparts[0],$cemeteryArray) !== false) {
									$level = 2; //Location
								} else $level=4; //County
							} else $level = 3; //Town
						}
					}
					break;

				default: //At least 4 parts. Must be a location
					$level = 2; //Location
				} //end of switch that checks the # of parts

			} else {
				//Not a USA place. We can't make inferences from the number of place parts, other than 1 part,
				//So multi-part names are left at zero.
				if ($commapartscount ==1) $level=6; //It must be a country
				else $level=0; 
			} //End of is it a USA place

			if ($level && $level!=$row['placelevel']) {
				//Don't update if the level is still zero or hasn't changed
				$query3 = "UPDATE $places_table SET placelevel = $level WHERE ID=$id";
echo "<br/>Updated $level, $placename = {$row['placelevel']}"; //xyzzy$result3 = tng_query($query3);
				$updatecount++;
			} else { 
				//Display places we couldn't find a level for.
				if (!$level) echo "<br/>$level -- {$admtext['mpu-skipped']} $placename = {$row['placelevel']}"; 
			}
		} //End if there is a placename
	} //Loop through places
	tng_free_result($result);
	//Display how many places we updated
	echo "<h4>$updatecount {$admtext['mpu-levelupdated']}.</h4><hr/>\n";
} //end function populatePlaceLevel 

function findInArray($haystack, $needles) {
	//Look for any one of the needles in the haystack.  
	//Return the index of the needle that was found. (The index might be zero.)
	//Return false if no needle was found.
	for ($i=0; $i<count($needles); $i++) {
		if (stripos($haystack, $needles[$i]) !== false) return $i;
	}
	return false;
}

function trimArray($myArray) {
	//Take an array that was created by explode, and make sure that each item is trimmed.
	for ($i=0; $i<count($myArray); $i++) {
		$myArray[$i] = trim($myArray[$i]);
	}
	return;
}

function loadStates() {
    //Load each of the 50 states and Washington, DC into two associative arrays.
    saveState("Alabama", "AL");
    saveState("Alaska", "AK");
    saveState("Arizona", "AZ");
    saveState("Arkansas", "AR");
    saveState("California", "CA");
    saveState("Colorado", "CO");
    saveState("Connecticut", "CT");
    saveState("Delaware", "DE");
    saveState("Florida", "FL");
    saveState("Georgia", "GA");
    saveState("Hawaii", "HI");
    saveState("Idaho", "ID");
    saveState("Illinois", "IL");
    saveState("Indiana", "IN");
    saveState("Iowa", "IA");
    saveState("Kansas", "KS");
    saveState("Kentucky", "KY");
    saveState("Louisiana", "LA");
    saveState("Maine", "ME");
    saveState("Maryland", "MD");
    saveState("Massachusetts", "MA");
    saveState("Michigan", "MI");
    saveState("Minnesota", "MN");
    saveState("Mississippi", "MS");
    saveState("Missouri", "MO");
    saveState("Montana", "MT");
    saveState("Nebraska", "NE");
    saveState("Nevada", "NV");
    saveState("New Hampshire", "NH");
    saveState("New Jersey", "NJ");
    saveState("New Mexico", "NM");
    saveState("New York", "NY");
    saveState("North Carolina", "NC");
    saveState("North Dakota", "ND");
    saveState("Ohio", "OH");
    saveState("Oklahoma", "OK");
    saveState("Oregon", "OR");
    saveState("Pennsylvania", "PA");
    saveState("Rhode Island", "RI");
    saveState("South Carolina", "SC");
    saveState("South Dakota", "SD");
    saveState("Tennessee", "TN");
    saveState("Texas", "TX");
    saveState("Utah", "UT");
    saveState("Vermont", "VT");
    saveState("Virginia", "VA");
    saveState("Washington", "WA");
    saveState("West Virginia", "WV");
    saveState("Wisconsin", "WI");
    saveState("Wyoming", "WY");
    saveState("District of Columbia", "DC");
}
function saveState($stateName,$stAb) {
    //Called by loadstates(), and loads one state name and abbreviation into the two
    //associative arrays that are used to associate state names and state abbreviations.
    global $stateNameArray, $stAbArray;
    $stAbArray[$stAb] = $stateName;
    $stateNameArray[$stateName] = $stAb;
}
