<?php
//admin_placeutilsload.php - created by Robin Richmond's place utilities mod
//This program reads a CSV file with place data, and loads geocodes and placelevels from the file to a TNG database.
//The CSV is generally presumed to have been created by a download program talking to a different database.
//
// Written Jan 6, 2014
//
include("begin.php");
include("adminlib.php");
$textpart = "findplace";
include("getlang.php");
include("$mylanguage/admintext.php");

tng_db_connect($database_host,$database_name,$database_username,$database_password) or exit;
$admin_login = 1;
include("checklogin.php");
include("version.php");

$helplang = findhelp("placesutilities_help.php");

$flags['tabs'] = $tngconfig['tabs'];
tng_adminheader( $admtext['places'], $flags );
?>

<script type="text/javascript" language="javascript">
function validateForm(thisform) {
	//There must be an input filename
	if (thisform.pcFile.value == "") {
		alert("<?php echo $admtext['mpu-nofilename']; ?>");
		return false;
	}
	return true;
}
// jQuery function to show/hide a list of places, and switch between buttons that say
// "see them" or "hide them"
function showlist(thisid) {
	if (jQuery("#"+thisid+"but").val()=="<?php echo $admtext['mpu-seethem']; ?>") {
		jQuery("#"+thisid).show();
		jQuery("#"+thisid+"but").val("<?php echo $admtext['mpu-hidethem']; ?>");
	} else {
		jQuery("#"+thisid).hide();
		jQuery("#"+thisid+"but").val("<?php echo $admtext['mpu-seethem']; ?>");
	}
}
jQuery(document).ready(function() {
	jQuery("#updatedrecordsbut").click(
		function(event) { showlist("updatedrecords"); }
	);
	jQuery("#nomatchingplacebut").click(
		function(event) { showlist("nomatchingplace"); }
	);
	jQuery("#nodatatoupdatebut").click(
		function(event) { showlist("nodatatoupdate"); }
	);
});
</script>
<style>
#updatedrecords {display:none;}
#nomatchingplace {display:none;}
#nodatatoupdate {display:none;}
</style>

</head>

<body background="img/background.gif">
<?php

	// Placetabs 0-3 are standard; 4-7 are from the Place Utilities mod.
	$placetabs[0] = array(1,"admin_places.php",$admtext['search'],"findplace");
	$placetabs[1] = array($allow_add,"admin_newplace.php",$admtext['addnew'],"addplace");
	$placetabs[2] = array($allow_edit && $allow_delete,"admin_mergeplaces.php",$admtext['merge'],"merge");
	$placetabs[3] = array($allow_edit,"admin_geocodeform.php",$admtext['geocode'],"geo");
	$placetabs[4] = array($allow_edit,"admin_placeutilslevel.php",$admtext['mpu-placelevels'],"level");
	$placetabs[5] = array($allow_edit,"admin_placeutilsload.php",$admtext['mpu-fromfile'],"fromfile");
	$placetabs[6] = array(1,"admin_placeutilssave.php",$admtext['mpu-savefile'],"savefile");
	$placetabs[7] = array($allow_edit,"admin_placeutilsoptions.php",$admtext['mpu-options'],"options");
	$innermenu = "<a href=\"#\" onclick=\"return openHelp('$helplang/placeutilities_help');\" class=\"lightlink\">{$admtext['help']}</a>";
	$menu = doMenu($placetabs,"fromfile",$innermenu);
	echo displayHeadline($admtext['places'] . " &gt;&gt; " . $admtext['mpu-loadplacedata'], "img/places_icon.gif",$menu,$message);
?>
<table width="100%" border="0" cellpadding="10" cellspacing="2" class="lightback">
<tr class="databack">
<td class="tngshadow normal">
<?php
	//See if the form was submitted
	if ($b1) {
		//It was, so upload the file to the server, and read and process it
		$filespec = uploadPcFile();

		$file1= fopen($filespec, 'r');
		if ($file1===false) {
			echo "<h3>{$admtext['mpu-openerr1']}</h3>";
			exit;
		}

		//Display the value of the Submit button that was selected
		echo "<h4>{$admtext['mpu-whattodo']}: $b1</h4>";
		$replaceall =($b1==$admtext['mpu-replaceall'] ); //This boolean value is used to build the update SQL statement
		$updatedrecords = 0; //Counts records that are updated.
		$nodatatoupdate = 0; //Counts database records that are already completely populated
		$nomatchingplace = 0; //Counts input data rows where there is no matching place name in the database
		$updatedrecordslist = $nodatatoupdatelist = $nomatchingplacelist = ""; //Lists corresponding to the counts
		$columnheadings = fgetcsv($file1);

		$placedata = fgetcsv($file1); //Read the first data row in the input file
		$fieldcount = count($placedata);
		$readGeocode = false;
		$readLevel = false;
		$query = "SELECT ID";
		if ($fieldcount>4) {
			$readGeocode = true;
			$query .= ", latitude, longitude, zoom";
		}
		if ($fieldcount==3 || $fieldcount==6) {
			$readLevel = true;
			$query .= ", placelevel";
		}
		while ($placedata) {
			$gedcom = $placedata[0];
			$placename = $placedata[1];
			if ($fieldcount == 3) {
				//Placelevel only
				$placelevel = $placedata[2];
			} else {
				$latitude = $placedata[2];
				$longitude = $placedata[3];
				$zoom = $placedata[4];
				if ($fieldcount==6) $placelevel = $placedata[5];
			}
			//Read the database record that matches the place name in the data row.
			$query .= " FROM $places_table WHERE place = \"$placename\" AND gedcom = \"$gedcom\"";
			$result = tng_query($query);
			$numrows = tng_num_rows( $result );
			if( $numrows == 1) {
				$row = tng_fetch_assoc( $result );
				$query2 = "";
				
				//Add each data field to the save query only if we're replacing all fields, or if the field is null or zero.
				if ($readGeocode) {
					if ($replaceall || !$row['longitude']) {
						$query2 .= $query2 ? ", " : "";
						$query2 .= "longitude = \"$longitude\"";
					}
					if ($replaceall || !$row['latitude']) {
						$query2 .= $query2 ? ", " : "";
						$query2 .= "latitude = \"$latitude\"";
					}
					if ($replaceall || !$row['zoom']) {
						$query2 .= $query2 ? ", " : "";
						$query2 .= "zoom = $zoom";
					}
				}
				if ($readLevel) {
					if ($replaceall || !$row['placelevel']) {
						$query2 .= $query2 ? ", " : "";
						$query2 .= "placelevel = $placelevel";
					}
				}
				//If we built anything into the query, complete the SQL syntax and execute it.
				if ($query2) {
					$query2 = "UPDATE $places_table SET " . $query2 . " WHERE ID = {$row['ID']}";
					$result2 = tng_query($query2);
					$updatedrecords++;
					$updatedrecordslist .= "<li>$placename</li>";
				} else {
					$nodatatoupdate++;
					$nodatatoupdatelist .="<li>$placename</li>";
				}
			} else {
				$nomatchingplace++;
				$nomatchingplacelist .="<li>$placename</li>";
			}
			tng_free_result($result);
			
			$placedata = fgetcsv($file1);
		} //Loop through each line of the input file.
		echo "<b>Updated $updatedrecords Places records.</b> " . 
			"<input type=\"button\" id=\"updatedrecordsbut\" value=\"{$admtext['mpu-seethem']}\" />";
		echo "<ol id=\"updatedrecords\">$updatedrecordslist</ol><br/>";
		echo "<b>$nomatchingplace Place names in the input file weren't found in the database.</b> " .
			"<input type=\"button\" id=\"nomatchingplacebut\" value=\"{$admtext['mpu-seethem']}\" />";
		echo "<ol id=\"nomatchingplace\">$nomatchingplacelist</ol><br/>";
		echo "<b>$nodatatoupdate records matched, but were already populated and thus weren't updated.</b> " .
			"<input type=\"button\" id=\"nodatatoupdatebut\" value=\"{$admtext['mpu-seethem']}\" />";
		echo "<ol id=\"nodatatoupdate\">$nodatatoupdatelist</ol>";
		echo "<br/><br/><hr/>";
	} //End If the Submit button was clicked
?>

	<form  enctype="multipart/form-data" method="post" onsubmit="return validateForm(this)">
<?php 
	//Specify the input file - only on the PC
	echo "{$admtext['mpu-fromyourcomputer']}: <input type=\"file\" name=\"pcFile\" size=\"60\"/>\n";
	//Two submit buttons
	echo "<br/><br/><input type=\"submit\" name=\"b1\" value=\"{$admtext['mpu-replaceall']}\" />\n";
	echo "<br/>{$admtext['text_or']} <input type=\"submit\" name=\"b1\" value=\"{$admtext['mpu-replacenull']}\" />\n";
?>
	</form>

</td>
</tr>
</table>

<?php echo "<div align=\"right\"><span class=\"normal\">$tng_title, v.$tng_version</span></div>"; ?>
</body>
</html>

<?php
///////////////////////////////////////////////////////////////////////////////////////////////////////////
function uploadPCFile() {
	//If the user selected a PC file, its name is in the $_FILES gobal.

	//We need to use two TNG variables that point to the server root folder and to
	//the relative path from the root to the gedcom folder.
	global $rootpath,$gedpath; 
	//Define the path to the upload folder
	$destination = "$rootpath$gedpath/";

	require_once('extensions/upload.class.php');  //Include the ps2 class definition
	//Use the ps2 class to check and upload the file defined in $_FILES
	try {
		$upload = new Ps2_Upload($destination);
		$upload->move();
		$uploadedFilename = $upload->getFilename();
		if (!$uploadedFilename){
			echo "One or more upload errors:<br>";
			print_r($upload->getMessages());
			exit;
		}
	} catch (Exception $e) {
		echo $e->getMessage();
		exit;
	}
	//Return the exact path to the uploaded file
	return $destination.$uploadedFilename;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////

