<?php
// admin-placeutilsoptions.php - Options form installed by the Admin Place Utils mod
// by Robin Richmond.
// This duplicates the place format options in the FTM-to-TNG Gedcom Converter mod,
// and, ultimately, will use the same config file.
// Designed to fit in a tab group with other Admin Place Utils mod. 
// These options are saved in extensions/placeformatconfig.php.
// Strings that are displayed on the page are in the language folder file cust_text.php
//
// This program does not do any database access.
//
include("begin.php");
include("adminlib.php");
$textpart = "findplace";
include("getlang.php");
include("$mylanguage/admintext.php");
$admin_login = 1;
include("checklogin.php");
include("version.php");

$helplang = findhelp("placeutilities.php");

$flags['tabs'] = $tngconfig['tabs'];
tng_adminheader( $admtext['mpu-pnoptions'], $flags );
?>
<script type="text/javascript" src="js/admin.js?v<?php echo $tng_version; ?>"></script>
<script type="text/javascript" src="js/mediautils.js?v<?php echo $tng_version; ?>"></script>
<style>
	form{margin:0;}
	ul,ol{margin-top:0;margin-bottom:0;}
	ol ol {list-style-type:lower-alpha;}
	legend{font-weight:bold;font-size:90%;}
	.checkbox{ margin: 0 0 0 1.5em;}
	.nowrap{white-space:nowrap;}
	.smallbutton{padding:0 .25em; font-size:85%;}
</style>
<script type="text/javascript" language="javascript">
function validateForm(thisform) {
	//We must make sure that extra state names and abbreviations come in pairs.
	//Also build vbar-delimited strings with the extra states and state abbreviations to pass to the action script.
	var states="";
	var stabs="";
	var x1; var x2;
	for (var i=0; i<parseInt(thisform.stateCount.value)+2; i++) {
		x1=document.getElementById("state"+i).value;
		x2=document.getElementById("stab"+i).value;
		if (x1!="" && x2!="") {
			//Both fields have values.  Store them in the states & abbreviations strings.
			states += ((states!="")?"|" : "") + x1; //Don't add a vbar before the first element
			stabs += ((stabs!="")?"|" : "" )+ x2;   //Don't add a vbar before the first element
		} else if ((x1!="" && x2=="") || (x1=="" && x2!="")) {
			//Only one of the fields has a value. That's an error
			alert("<?php echo $admtext['cgerrstatepair']; ?>");
			return false;
		}
	}
	//Store the state and state abbreviation strings in fields
	thisform.stateNames.value = states;
	thisform.stateAbbrevs.value = stabs;
	return true;
}
</script>
</head>

<body background="img/background.gif">
<?php

	// Placetabs 0-3 are standard; 4-7 are from the Place Utilities mod.
	$placetabs[0] = array(1,"admin_places.php",$admtext['search'],"findplace");
	$placetabs[1] = array($allow_add,"admin_newplace.php",$admtext['addnew'],"addplace");
	$placetabs[2] = array($allow_edit && $allow_delete,"admin_mergeplaces.php",$admtext['merge'],"merge");
	$placetabs[3] = array($allow_edit,"admin_geocodeform.php",$admtext['geocode'],"geo");
	$placetabs[4] = array($allow_edit,"admin_placeutilslevel.php",$admtext['mpu-placelevels'],"level");
	$placetabs[5] = array($allow_edit,"admin_placeutilsload.php",$admtext['mpu-fromfile'],"fromfile");
	$placetabs[6] = array($allow_edit,"admin_placeutilssave.php",$admtext['mpu-savefile'],"savefile");
	$placetabs[7] = array($allow_edit,"admin_placeutilsoptions.php",$admtext['mpu-options'],"options");
	$innermenu = "<a href=\"#\" onclick=\"return openHelp('$helplang/placeutilities_help');\" class=\"lightlink\">{$admtext['help']}</a>";
	$menu = doMenu($placetabs,"options",$innermenu);
	echo displayHeadline($admtext['places'] . " &gt;&gt; " . $admtext['mpu-pnoptions'], "img/places_icon.gif",$menu,$message);

	//See if the submit button was selected. If so, we need to save the form to the file.
	//Always write to the same file in the extensions folder.
	if ($b1) {
		$outputFilespec = "$rootpath/extensions/placeformatconfig.php";
		$file2 = fopen($outputFilespec,"wt");
		fwrite($file2,"<?php\n");
		fwrite($file2,"//This config file is used by admin_placeutilslevel.php and (will be used by) ftm2tngform.php\n");
		fwrite($file2,"//See the help file for those programs for explanations of the meanings of each variable.\n");
		fwrite($file2,"//Last written by admin_placeutilsoptions.php on " . date('Y-m-d H:i:s') . "\n");
		fwrite($file2,"\$usaText = \"$txtUSAText\";                  //Text to replace USA, United States, etc. \n");
		fwrite($file2,"\$extraStateNames = \"$stateNames\";\n");
		fwrite($file2,"\$extraStateAbbrvs = \"$stateAbbrevs\";\n");
		fwrite($file2,"\$blnUseFullname = " . ($radioFullOrAbbrv=="fullname" ? "true" : "false") . ";        //Use state fullname (vs abbrev) for a state w/ a city or county\n");
		fwrite($file2,"\$countyWithCity = \"$txtCountyWithCity\";           //Text to replace County, Co, Co. when there IS a city\n");
		fwrite($file2,"\$countyWithoutCity = \"$txtCountyWithoutCity\";      //Text to replace County, Co, Co. when there is NOT a city\n");
		fwrite($file2,"\$nonCounties = \"$txtNonCounties\";\n");
		fwrite($file2,"\$nonCityStrings = \"$txtNonCityStrings\";\n");
		fwrite($file2,"\$cemeteryStrings = \"$txtCemeteryStrings\";\n");
		fwrite($file2,"\$blnCompressPlaces = " . ($cbxCompressPlaces ? "true" : "false") . ";     //Remove spaces after commas in place names\n");
		fwrite($file2,"\$placesToIgnore = \"$txtPlacesToIgnore\";\n");
		//End the file by closing PHP
		fwrite($file2,"?>\n");
		fclose($file2);
		echo "<h4>{$admtext['optionssaved']}</h4>\n";
	}

// Include the site-specific config file if it exists. Otherwise, include the distribution version.
if (file_exists("extensions/placeformatconfig.php")) include("extensions/placeformatconfig.php"); 
else include("extensions/placeformatconfig-placedistrib.php");

?>

<table width="100%" border="0" cellpadding="10" cellspacing="2" class="lightback">
<tr class="databack">
<td class="tngshadow normal">
<form id="myform" name="myform" action="" method="post" onsubmit="return validateForm(this);">
	<!-- the values of these two hidden fields will be set by the form validation function -->
	<input type=hidden name=stateNames value="">
	<input type=hidden name=stateAbbrevs value="">

	<ol>
<?php
		//Text to replace USA... save in a hidden field.  We don't need it here.
		echo "<input type=\"hidden\" name=\"txtUSAText\" value=\"{$admtext['usaText']}\" />\n";
		  //Button to modify states
		echo "<li>\n";
		  echo "<input name=\"btnModifyStates\" type=\"button\" class=\"smallbutton\" value=\"{$admtext['statesbutton']}\"\n";
			  echo " onclick=\"document.getElementById('statesform').style.display='block'\" />\n";
		  echo "<fieldset id=\"statesform\" style=\"display:none;\"><legend>{$admtext['stateslegend']}</legend>\n";
				echo $admtext['statesnote1'] . $admtext['statesnote2'] . "\n";
				//Take the two vbar-delimited variables for states and abbreviations, and turn them into arrays.
				$extraStates=array();
				$extraStAbs=array();
				$extraStates=explode("|", $extraStateNames);
				$extraStAbs =explode("|", $extraStateAbbrvs);
				//create a hidden field that holds the number of extra states (i.e. the size of the arrays)
				echo "<input type=hidden name=stateCount value='" . count($extraStates) ."'>";
				//Inside a two-column table, loop through one of the arrays, displaying a state name & abbreviation on each row
				echo "<table border=0><tr><th>{$admtext['cgstatename']}</th><th>{$admtext['cgstateabbrev']}</th></tr>\n";
				for ($i=0; $i<count($extraStates); $i++) {
					echo "<tr><td><input type=\"text\" id=\"state$i\" size=\"20\" value=\"{$extraStates[$i]}\"></td>\n";
					echo "<td><input type=\"text\" id=\"stab$i\" size=\"10\" value=\"{$extraStAbs[$i]}\"></td></tr>\n";
				}
				//Display two extra blank rows for additional dummy states
				echo "<tr><td><input type=\"text\" name=\"state$i\" id=\"state$i\" size=\"20\"></td>\n";
				echo "<td><input type=\"text\" name=\"stab$i\" id=\"stab$i\" size=\"10\"></td></tr>\n";
				echo "<tr><td><input type=\"text\" name=\"state" . ($i+1) . "\" id=\"state" . ($i+1) . "\" size=\"20\"></td>\n";
				echo "<td><input type=\"text\" name=\"stab" . ($i+1) . "\" id=\"stab" . ($i+1) . "\" size=\"10\"></td></tr>\n";

				echo "</table>\n";
				echo "<input type=\"button\" class=\"smallbutton\" value=\"{$admtext['cgclosebutton']}\" onclick=\"document.getElementById('statesform').style.display='none'\" />\n";
			echo "</fieldset>\n";
			echo "</li>\n";
		//Back to main form 

		//Use fullname or abbrev - save in hidden field
			$x = ($blnUseFullname) ? "fullname" : "abbrev";
			echo "<input type=\"hidden\" name=\"radioFullOrAbbrv\" value=\"$x\" />\n";
		//County designator to use when there IS as city
		echo "<li><label>" . $admtext['cgcountywithcity'];
			echo "<input type=\"text\" name=\"txtCountyWithCity\" value=\"$countyWithCity\"></label></li>\n";
		//County designators to use when there IS NOT as city
		echo "<li><label>" . $admtext['cgcountywithoutcity'];
			echo "<input type=\"text\" name=\"txtCountyWithoutCity\" value=\"$countyWithoutCity\"></label></li>\n";
		//Places that act as counties
		echo "<li><label>" . $admtext['cgnoncounties'] . "<br />\n";
		   echo "<textarea name=\"txtNonCounties\" rows=\"3\" cols=\"80\">$nonCounties</textarea></label>\n";
		   echo "</li>\n";
		//Strings within counties that aren't towns
		echo "<li><label>" . $admtext['cgnoncities'] . "<br />\n";
		   echo "<textarea name=\"txtNonCityStrings\" rows=\"3\" cols=\"80\">$nonCityStrings</textarea></label>\n";
		   echo "</li>\n";
		//Cemetery strings
		echo "<li><label>" . $admtext['cgcemeteries'] . "<br />\n";
			echo "<textarea name=\"txtCemeteryStrings\" rows=\"3\" cols=\"80\">$cemeteryStrings</textarea></label>\n";
			echo "</li>\n";
		//Places to ignore completely
		echo "<li><label>" . $admtext['mpu-place2ignore'] . "<br />\n";
			echo "<textarea name=\"txtPlacesToIgnore\" rows=\"3\" cols=\"80\">$placesToIgnore</textarea></label>\n";
			echo "</li>\n";
		//Compress places - hidden field, since we don't need it here
		if ($blnCompressPlaces)
			echo "<input type=\"hidden\" name=\"cbxCompressPlaces\" value=\"yes\" />\n";
?>
	</ol>
<input type="submit" name="b1" value="<?php echo $admtext['saveoptions']; ?>" /> 
</form>
</td>
</tr>
</table>


<?php echo "<div align=\"right\"><span class=\"normal\">$tng_title, v.$tng_version</span></div>"; ?>
</body>
</html>
