<?php
//admin_placeutilssavefile.php - created by Robin Richmond's place utilities mod.
// Invoked by admin_placeutilsave.php.
// This program writes the CSV data to the PC.  It sends no output to the browser, and just exits,
// leaving the calling page in the browser.
// Input form parameters:
// - $geocodes - Non-null if the user wants geocode data in the CSV file.
// - $level - Non-null if the user wants place levels in the CSV file.
// - $level0only - Non-null if the user wants only places with the value zero for placelevel.
// - $tree1 - The tree abbreviation (not description) to use (can be null, meaning all trees)
// - $treename - The descriptive name of the selected tree.
// Output parameter:
// - $message - we want to pass this back to the calling program, but I haven't gotten it to work.

include("begin.php");
include("adminlib.php");
$textpart = "findplace";
include("getlang.php");
include("$mylanguage/admintext.php");

tng_db_connect($database_host,$database_name,$database_username,$database_password) or exit;
$admin_login = 1;
include("checklogin.php");
include("version.php");

//Build the CSV heading string and the SQL query based on the flags that determine which fields to include. 
$heading = "Tree, Place";
$query = "SELECT gedcom, place";
if ($geocodes) {
	$heading .= ", Latitude, Longitude, Zoom";
	$query .= ", latitude, longitude, zoom";
}
if ($levels) {
	$heading .= ", Level";
	$query .= ", placelevel";
}
// That completes the heading.  Continue building the SQL query.
// The treemessage is incorporated into the message if a tree has been selected.
$query .= " FROM $places_table WHERE 1 ";
if ($tree1 && !$tngconfig['places1tree']) {
	$query .= " AND gedcom = \"$tree1\" ";
$treemessage = " {$admtext['mpu-fromtree']} $treename ";
} else $treemessage = "";

if ($level0only) $query .= " AND placelevel=0 ";

$query .= " ORDER BY place";
//The query is complete; execute it.
$result = tng_query($query);
if( $result ) {
	// Output some headers so that the file is downloaded rather than displayed
	header('Content-Type: text/csv; charset=utf-8');
	header('Content-Disposition: attachment; filename=placedata.csv');
	// create a file pointer connected to the output stream
	$output = fopen('php://output', 'w');
	// output the column headings
	fwrite($output, $heading."\n");
	//Output each result in the result set in CSV format
	while( $row = tng_fetch_assoc( $result ) ) fputcsv($output, $row);
	//That's it... close the output stream.
	fclose ($output);

//$message = tng_num_rows($result) . " places $treemessage written to the file"; 
}
//else $message = "{$admtext['mpu-noplaces']} $treemesage";
//$_SESSION("message") = $message;
// header( "Location: admin_placeutilssave.php?message=" . urlencode($message) );
?>

