<?php
include("../../helplib.php");
echo help_header("Help: Administrative Place Utilities");
?>

<body class="helpbody">
<a name="top"></a>
<table width="100%" border="0" cellpadding="10" cellspacing="2" class="tblback normal">
<tr class="fieldnameback">
	<td class="tngshadow">
		<p style="float:right; text-align:right" class="smaller menu">
			<a href="http://tngforum.us" target="_blank" class="lightlink">TNG Forum</a> &nbsp; | &nbsp;
			<a href="http://tng.lythgoes.net/wiki" target="_blank" class="lightlink">TNG Wiki</a><br />
			<a href="places_help.php" class="lightlink">&laquo; Help: Places</a> &nbsp; | &nbsp;
		</p>
		<span class="largeheader">Help: Administrative Place Utilities</span>
		<p class="smaller menu">
			<a href="#placelevel" class="lightlink">Set Place Level</a> &nbsp; | &nbsp;
			<a href="#loadplacedata" class="lightlink">Load Place Data from a CSV file</a> &nbsp; | &nbsp;
			<a href="#saveplacedata" class="lightlink">Save Place Data to a CSV file</a>
			<a href="#options" class="lightlink">Update Place Format Options</a>
		</p>
	</td>
</tr>
<tr class="databack">
	<td class="tngshadow">

		<p class="subheadbold" id="placelevel">Administrative Place Utilities</p>
		<p>This help file describes four programs that were installed by the Admin Place Utilities mod,
		and are accessible through tabs in the Administration >> Places page. The collective purpose of these utilities is to</p>
		<ol><li>Set the Place Level field of the Places table,</li>
			<li>Copy Place Levels to and from a CSV (comma-separated-values) file where values that could not be determined by the utility's algorithmm so they can be edited by hand easily.</li>
			<li>Copy geocode information and/or place levels from one database to another - particularly from a production database to a test database (or vice-versa).
		</ol>
	</td>
</tr>
<tr class="databack">
	<td class="tngshadow">
		<p style="float:right"><a href="#top">Top</a></p>
		<p class="subheadbold" id="placelevel">Set Place Level</p>
		<p>This utility, at the <strong>Placelevels</strong> tab, sets the place levels for USA places and countries (not places inside other countries).
		It uses options defined by the <a href="#options"><strong>Options</strong> tab</strong></a>.
		</p>
		<p>
		USA places name must end with "USA" or "United States", or a state name or abbreviation.
		The Place Format Options allow you to define non-standard "Pseudo-states" such as "East Texas" or "GA or TN" that act like states, but aren't really states. 
		U.S. territories and protectorates like Puerto Rico and Guam are not defined in the list of states that this program uses, 
		and must be defined in the list of "Pseudo-states" if you want them to be assigned same placelevel as states.
		</p>
		<p>Among non-USA placenames, if there is no comma in the place name, it is recognized as a country. 
		But the placelevel for all other non-USA place names is left undefined.
		</p>
		</p>A simple method for manually setting the placelevel for non-USA place names is to:
		</p>
		<ol><li>Run the <a href="#saveplacedata">Save Place Data to a CSV file</a> utility from the appropriate tab on the Administration >> Places menu,
				<ul><li>You may wish to write just place levels to the file (i.e. omit geocode data), and limit the CSV file to places with a place level of zero.</li>
				</ul></li>
			<li>Open the resulting CSV file in a spreadsheet program for editing.</li>
			<li>Edit the place level values in the spreadsheet
				<ul><li>You should leave all columns except place level alone, and make sure not to save the file as a spreadsheet file, but to leave it in CSV format.</li>
			<li>Reload the data by running the <a href="#loadplacedata">Load Place Data from a CSV file</a> utility from the appropriate tab on the Administration >> Places menu.</li>
		</ol>
	</td>
</tr>
<tr class="databack">
	<td class="tngshadow">
		<p style="float:right"><a href="#top">Top</a></p>
		<p class="subheadbold" id="loadplacedata">Load Place Data from a CSV file</p>

		<p>This utility program reads a CSV file containing lines consisting of:</p>
		<ul><li>A tree id (not the tree's descriptive name)</li>
			<li>A place name</li>
			<li>Optionally, the place's geocode data, i.e. the place's latitude, longitude, and zoom level.</li>
			<li>Optionally, the "place level", which indicates now precise the place name is.</li>
		</ul>
		<p>See <a href="#saveplacedata">Save Place Data to a CSV file</a> for information on how to create such a file, and to select whether the file contains geocode data and/or place levels.
		</p>
		<span class="optionhead">Purpose</span>
		<p>The general purpose of this utility is to populate Place data in a local database from the place data in a corresponding production database.  The idea is to</p>
		<ol><li>Run the <a href="#saveplacedata">Save Place Data to a CSV file</a> utility on a production platform, and then</li>
			<li>Run the Load Place Data from a CSV file utility on the test platform.</li>
		</ol>
		<p>Where place names match in the production and local databases, the geocode data and/or place level values will be loaded into the local database.
		</p>
		<p>This utility can also be used to load hand-edited place levels into the database, as detailed in the description of the <a href="#placelevel">Set Place Level</a> utility.
		</p>
		<span class="optionhead">Options</span>
		<p>You must enter or select a filename from your local PC</p>
		<p>Then, you may select either of two options:</p>
		<ol><li>Load all data from the file (where places match), or</li>
			<li>Replace database fields only if they are empty or zero</li>
		</ol>
		<p>The program will read and process the file, and tell you how many places it processed.  You may also view the places that it did (and didn't) process.
		</p>
	</td>
</tr>
<tr class="databack">
	<td class="tngshadow">
		<p style="float:right"><a href="#top">Top</a></p>
		<p class="subheadbold" id="saveplacedata">Save Place Data to a CSV file</p>
		<p>
		This utility program creates the place data file that is read by the utility that <a href="#loadplacedata">Loads Place Data from a CSV file</a>. This utility allows the user to select a tree, and to indicate whether to</p>
		<ol><li>Include the geocode fields,</li>
			<li>Include the place level field, and</li>
			<li>Limit the file to places with a place value of zero.</li>
		</ol>
		<p>Note that the filename in which the CSV file is place is fixed.
		Your ability to change the name of the file and location where it is stored is determined by your web browser.
		Most browsers (these days) seem to always put downloaded files into a standard downloads folder on your computer.
		</p>
		<p>If you want to edit the CSV file (for example, to set place levels that the place level program couldn't determine), you should be able to open the CSV in a spreadsheet program readily.
		</p>
		See the descriptions of the <a href="#loadplacedata">Load Place Data</a> and <a href="#placelevel">Set Place Levels</a> utilities for reasons to use this utility.
	</td>
</tr>
<tr class="databack">
	<td class="tngshadow">
		<p style="float:right"><a href="#top">Top</a></p>
		<p class="subheadbold" id="options">Update Place Format Options</p>

		<p>This utility program reads reads and updates the configuration file placeformatconfig.php, in the TNG extensions subfolder.
		These options are also used by the FTM-to-TNG GEDCOM Converter mod 
		(which, at this writing, uses a different config file, but will be updated to share extensions/placeformatconfig.php). 
		The options available to this program are:</p>
		<ol>
			<li>A set of "Pseudo-states" such as "East Texas" or "SC and GA" that fill the role of states in place names. The list is hidden behind a button.  Clicking the button reveals a two-column list of the "Pseudo-states" and their abbreviations.  Most pseudo-state abbreviations are not likely to be relevant in this program, but they can be relevant in other programs that use this configuration file.</li>
			<li>The "county designator" (generally "County" or "Co") used to identify a county when there IS a town in the place name.</li>
			<li>The county designator used to identify a county when there IS a town in the place name.<br />
				<span style="font-size:85%;">(Note: Many genealogists always put "County" next to all county names, but some don't.  The mod author, in particular, uses "Co" to identify a county when necessary, and no county designator when the the it's clear from the context that the locale is a county.  For instance - "Harris Co, TX" distinguishes the county from the town of "Harris, TX".  But in the name "Houston, Harris, TX", no county designator is needed.)</span></li>
			<li>A list of places that "act" like counties, but aren't, such as Staten Island,NY and Shenandoah Valley, VA".  These places might be seen as towns if not for their presence in this list.</li>
			<li>A list of substrings that are used in some placenames, but don't really add placelevel specificity.  The only example I have come up with is "In Battle". The placename "In Battle, Bradley County, Tennessee" should really be placelevel=4, for County.
			<span style="font-size:85%;">(Of course, it could be argued that "In Battle" should be a note, even if the battle name is not known.)</span>
			<li>A list of substrings such as "Cemetery, Memorial Garden, and Churchyard" that identify cemeteries.  These substrings are used to identify cemeteries as locations rather than towns when they are listed without a town, as in "Fairview Cemetery, Washington County, TN".</li>
			<li>A list of places to ignore completely. For the mod author's database, the list is "(none),at sea".  These places would be identified as countries if not for their presence in this list.</li>
			<li>(I have not included a list of strings that would identify other locations within towns such as "Street", "Hospital", "Medical Center", "Institute", "University", etc. It is my impression that most facilities other than cemeteries are identified in notes, not in place names.  But if you see a need to identify facilities other than cemeteries, please let me know via the support form in the mod Wiki article.)
		</ol>
		<p>
		Note that if you were to look at the configuration file directly, you would see other option variables not listed here.  Those other option variable are used by other programs that use the same configuration file - particularly the FTM-to-TNG GEDCOM converter, which uses these options to change place names to a particular format.
		</p>
	</td>
</tr>

</table>
</body>
</html>